<?php
/**
 * @copyright	Copyright (C) 2009-2017 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingemerald extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
	}

	function onAcyDisplayFilters(&$type){
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_emerald')) return '';
		$allPlans = acymailing_loadObjectList('SELECT id, name, group_id FROM #__emerald_plans WHERE published = 1 ORDER BY name ASC');
		$allGroups = acymailing_loadObjectList('SELECT id, name FROM #__emerald_plans_groups WHERE published = 1 ORDER BY name ASC');

		$plansAndGroups = [acymailing_selectOption(0, 'Any')];
		foreach($allGroups as $oneGroup){
			$plansAndGroups[] = acymailing_selectOption('group_'.$oneGroup->id, $oneGroup->name);
			foreach($allPlans as $onePlan){
				if($onePlan->group_id != $oneGroup->id) continue;
				$plansAndGroups[] = acymailing_selectOption($onePlan->id, ' - '.$onePlan->name);
			}
		}

		acymailing_loadLanguageFile('com_emerald',JPATH_SITE);

		$status = array();
		$status[] = acymailing_selectOption('0', acymailing_translation('ALL_STATUS'));
		$status[] = acymailing_selectOption('1', acymailing_translation('JOOMEXT_YES'));
		$status[] = acymailing_selectOption('-1', acymailing_translation('JOOMEXT_NO'));

		$inoperator = acymailing_get('type.operatorsin');
		$inoperator->js = 'onchange="countresults(__num__)"';

		$return = '<div id="filter__num__emeraldsub">';
		$return .= $inoperator->display('filter[__num__][emeraldsub][type]');
		$return .= acymailing_select($plansAndGroups, 'filter[__num__][emeraldsub][planid]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= ' '.acymailing_translation('ACTIVATED').': '.acymailing_select($status, 'filter[__num__][emeraldsub][substate]', 'class="inputbox" onchange="countresults(__num__)" size="1"', 'value', 'text');
		$return .= '<br /> <input type="text" name="filter[__num__][emeraldsub][cdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" /> < '.acymailing_translation('CREATED_DATE').' < <input type="text" name="filter[__num__][emeraldsub][cdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" />';
		$return .= '<br /> <input type="text" name="filter[__num__][emeraldsub][pdateinf]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" /> < '.(acymailing_translation('EPLUNLIST') == 'EPLUNLIST' ? 'Purchase Date' : acymailing_translation('EPLUNLIST')).' < <input type="text" name="filter[__num__][emeraldsub][pdatesup]" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" style="width:100px" />';
		$return .= '</div>';
		$type['emeraldsub'] = 'Emerald';
		$acyconfig = acymailing_config();
		if(version_compare($acyconfig->get('version'),'4.9.3','<')) echo 'Please update AcyMailing, the Emerald plugin may not work properly with this version';

		return $return;
	}

	function onAcyProcessFilterCount_emeraldsub(&$query,$filter,$num){
		$this->onAcyProcessFilter_emeraldsub($query,$filter,$num);
		return acymailing_translation_sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_emeraldsub(&$query,$filter,$num){
		$join = '#__emerald_subscriptions AS emerald'.$num.' ON sub.userid = emerald'.$num.'.user_id';
		if(!empty($filter['planid'])) {
			if (strpos($filter['planid'], 'group_') !== false){
				$plans = acymailing_loadResultArray('SELECT id FROM #__emerald_plans WHERE group_id = '.intval(str_replace('group_', '', $filter['planid'])));
				acymailing_arrayToInteger($plans);
				$join .= ' AND emerald'.$num.'.plan_id IN ('.implode(',', $plans).')';
			}else{
				$join .= ' AND emerald'.$num.'.plan_id = '.intval($filter['planid']);
			}
		}

		$where = array();

	 	if(!empty($filter['cdateinf'])){
	 		$filter['cdateinf'] = acymailing_replaceDate($filter['cdateinf']);
	 		if(!is_numeric($filter['cdateinf'])) $filter['cdateinf'] = strtotime($filter['cdateinf']);
	 		if(is_numeric($filter['cdateinf'])) $filter['cdateinf'] = strftime('%Y-%m-%d %H:%M:%S',$filter['cdateinf']);
		 	$where[] = 'emerald'.$num.'.created > '.acymailing_escapeDB($filter['cdateinf']);
	 	}

	 	if(!empty($filter['cdatesup'])){
	 		$filter['cdatesup'] = acymailing_replaceDate($filter['cdatesup']);
	 		if(!is_numeric($filter['cdatesup'])) $filter['cdatesup'] = strtotime($filter['cdatesup']);
	 		if(is_numeric($filter['cdatesup'])) $filter['cdatesup'] = strftime('%Y-%m-%d %H:%M:%S',$filter['cdatesup']);
		 	$where[] = 'emerald'.$num.'.created < '.acymailing_escapeDB($filter['cdatesup']);
	 	}

	 	if(!empty($filter['pdateinf'])){
	 		$filter['pdateinf'] = acymailing_replaceDate($filter['pdateinf']);
	 		if(!is_numeric($filter['pdateinf'])) $filter['pdateinf'] = strtotime($filter['pdateinf']);
	 		if(is_numeric($filter['pdateinf'])) $filter['pdateinf'] = strftime('%Y-%m-%d %H:%M:%S',$filter['pdateinf']);
		 	$where[] = 'emerald'.$num.'.purchased > '.acymailing_escapeDB($filter['pdateinf']);
	 	}

	 	if(!empty($filter['pdatesup'])){
	 		$filter['pdatesup'] = acymailing_replaceDate($filter['pdatesup']);
	 		if(!is_numeric($filter['pdatesup'])) $filter['pdatesup'] = strtotime($filter['pdatesup']);
	 		if(is_numeric($filter['pdatesup'])) $filter['pdatesup'] = strftime('%Y-%m-%d %H:%M:%S',$filter['pdatesup']);
		 	$where[] = 'emerald'.$num.'.purchased < '.acymailing_escapeDB($filter['pdatesup']);
	 	}

		if(!empty($filter['substate'])){
			if($filter['substate'] == 1){
				$where[] = 'emerald'.$num.'.extime > NOW() OR emerald'.$num.'.extime = "0000-00-00 00:00:00"';
				$where[] = 'emerald'.$num.'.ctime < NOW()';
				$where[] = 'emerald'.$num.'.activated = 1';
				$where[] = 'emerald'.$num.'.published = 1';
				$where[] = 'emerald'.$num.'.access_limit = 0 OR (emerald'.$num.'.access_limit > 0 AND emerald'.$num.'.access_count < emerald'.$num.'.access_limit)';
			}else{
				$where[] = 'emerald'.$num.'.extime < NOW() ' .
							'OR emerald'.$num.'.ctime > NOW() ' .
							'OR emerald'.$num.'.activated <> 1 ' .
							'OR (emerald'.$num.'.access_limit > 0 ' .
								'AND emerald'.$num.'.access_count >= emerald'.$num.'.access_limit) ' .
							'OR emerald'.$num.'.published <> 1';
			}
		}

	 	if(!empty($where)) $join .= ' AND ('.implode(') AND (', $where).')';

		if($filter['type'] == 'IN'){
			$query->join['emerald'.$num] = $join;
		}else{
			$query->leftjoin['emerald'.$num] = $join;
			$query->where['emerald'.$num] = 'emerald'.$num.'.plan_id IS NULL';
		}
	}
}//endclass